<template>
    <div class="settings_block">
        <div class="settings_block__content flex-wrap">
            <div class="col-12 col-xl-6 settings_block__item">
                <div class="title">
                    Timezone settings
                </div>
                <v-select
                    v-model="items.defaultShopTimeZone"
                    :options="settings.listTimeZones"
                    label="value"
                    value="key"
                    size="sm"
                    @input="save()"
                />

                <span class="desc">
                    *Set your default timezone to accurately schedule SMS messages.
                </span>
            </div>
            <div class="col-12 col-xl-6 settings_block__item">
                <div class="title">
                    Quiet hours
                    <b-form-checkbox
                        v-model="items.quietHours.isActive"
                        class="switcher"
                        switch
                        size="lg"
                        @input="$emit('saveSwitch', {type: 'sms', key: 'quietHours', name: 'Quiet hours'})"
                    />
                </div>
                <QuietHours
                    v-if="items.quietHours.isActive"
                    :value="items.quietHours"
                    @input="items.quietHours.from = $event.from, items.quietHours.to = $event.to, save()"
                />
                <span class="desc desc__quiet_hours">*Works based on the time zone you have selected.
                    Do not send any text messages within the specified hours of a day.
                </span>
            </div>
            <div class="col-12 col-xl-6 settings_block__item">
                <div class="title">
                    Safe Send
                    <b-form-checkbox
                        v-model="items.safeSendSms.isActive"
                        class="switcher"
                        switch
                        size="lg"
                        @input="$emit('saveSwitch', {type: 'sms', key: 'safeSendSms', name: 'Safe send'})"
                    />
                </div>
                <span class="desc desc__safe_send mb-3">
                    *If you turn it on, the messages will be not sent to the customers that received an SMS from you in the last X hours:
                </span>
                <SafeSend
                    v-if="items.safeSendSms.isActive"
                    v-model="items.safeSendSms.value"
                    :type="items.safeSendSms.type"
                    :default="10"
                    @updType="items.safeSendSms.type = $event, save()"
                    @input="save()"
                />
                <b-form-group
                    v-if="items.safeSendSms.isActive"
                    style="margin-top: 15px; margin-bottom: 0;"
                >
                    <b-form-radio-group
                        v-model="items.safeSendSms.skip"
                        name="radios-stacked"
                        plain
                        stacked
                        button-variant="outline-secondary"
                        size="lg"
                        :options="safeSendSkipOptions"
                        @change="save()"
                    />
                </b-form-group>
            </div>
            <div
                v-if="settings.countries"
                class="col-12 col-xl-6 settings_block__item"
            >
                <div class="title">
                    Countries and prices
                </div>
                <Accardion
                    no-open
                    title="Countries"
                    @onClick="openModalCountries"
                />
            </div>
            <div class="col-12 col-xl-6 settings_block__item mb-0">
                <div class="title">
                    Max SMS price
                    <b-form-checkbox
                        v-model="items.maxSmsPrice.isActive"
                        class="switcher"
                        switch
                        size="lg"
                        @input="$emit('saveSwitch', {type: 'sms', key: 'maxSmsPrice', name: 'Max SMS price'})"
                    />
                </div>
                <Price
                    v-if="items.maxSmsPrice.isActive"
                    :value="items.maxSmsPrice.value"
                    @input="items.maxSmsPrice.value = $event, save()"
                />
                <span class="desc mb-3">*Do not send messages if they cost more than:</span>
            </div>
        </div>
        <ModalCountries
            v-if="showModalCountries"
            :countries="settings.countries"
            :show="showModalCountries"
            @close="openModalCountries"
            @input="save()"
            @saveCountries="save(), $emit('saveCountries'), openModalCountries(), scrollTop()"
        />
    </div>
</template>

<script>
import ModalCountries from "./sms/ModalCountries.vue";
import QuietHours from "./sms/QuietHours.vue";
import SafeSend from "./sms/SafeSend.vue";
import Price from "@/components/elements/Price.vue";
import Accardion from "@/components/elements/Accardion"
import {settings} from "@/mixins/settings";
import vSelect from 'vue-select'

export default {
    components: {
        QuietHours,
        SafeSend,
        Price,
        Accardion,
        ModalCountries,
        vSelect,
    },
    mixins: [settings],
    props: ["settings"],
    data() {
        return {
            data: null,
            showModalCountries: false,
            safeSendSkipOptions: [
                {text: 'Queue the reminder that is scheduled to the safe send hours', value: false,},
                {text: 'Skip the reminder that is scheduled to the safe send hours', value: true},
            ],
            items: {
                defaultShopTimeZone: "",
                quietHours: {value: null, isActive: false},
                safeSendSms: {value: null, isActive: false},
                countries: "",
                maxSmsPrice: {value: 0, isActive: false},
            },
        };
    },
    async created() {
        await this.getData();
        const defaultShopTimeZoneValue = this.items.defaultShopTimeZone
        this.items.defaultShopTimeZone =  this.settings.listTimeZones.find(el => el.key == defaultShopTimeZoneValue) || this.settings.listTimeZones[0] 
    },
    methods: {
        save(type) {
            const items = JSON.parse(JSON.stringify(this.items))
            items.defaultShopTimeZone = items.defaultShopTimeZone && items.defaultShopTimeZone.key
            const emitObj = {
                items
            }
            if(type) emitObj.type = 'changeTab'
            this.$emit("save", emitObj);
        },
        openModalCountries() {
            this.showModalCountries = !this.showModalCountries
        },
        scrollTop() {
            window.scrollTo({
                top: 0,
                behavior: "smooth"
            });
        }
    },
};
</script>

<style lang="scss" scoped>
@import "../../../../css/settings/index.scss";

</style>
<style lang="scss">
@import "vue-select/src/scss/vue-select.scss";
</style>